//
// vfive: Vector Field Interactive Visualization Environment
//
// snapstate.c++
//
//                by Kageyama, Akira  (kage@nifs.ac.jp)  1999.03.16
//  
// Please read the file "LICENCE_ja.txt"(in Japanese) or "LICENCE_en.txt" (in English)
// before you use this software. 

#include "vfive.h"

Snapstate::Snapstate()
{
  head_phi_ = 0.0;          // angle (in radian): NOTE! phi=0 is y-axis.
  time_sec_ = 0.0;          // seconds from the program stated

  for(int i=0;i<3;i++){
   head_pos[i]   = 0.0;        // head position
   head_front[i] = 0.0;      // head direction
   wand_pos[i]   = 0.0;        // wand position in simulation coord.
  }
}

void
Snapstate::record_head_info()
{
  CAVEGetVector(CAVE_HEAD_FRONT_NAV, head_front);
  CAVEGetPosition(CAVE_HEAD_NAV, head_pos);

  float x = head_front[0];
  float y = head_front[1];

  head_phi_ = atan2(-x,y);  // This "phi"=0 is toward y-axis.
}

void
Snapstate::record_wand_info()
{
  CAVEGetPosition(CAVE_WAND_NAV, wand_pos);
}



