//
// N.Ohno 2008.1.31
//


// Please read the file "LICENCE_ja.txt"(in Japanese) or "LICENCE_en.txt" (in English)
// before you use this software. 

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <GL/glut.h>

char strings[60];
const int panel_w = 128;
const int panel_h = 64;

#ifdef ROMAN24
#define FONT_KIND GLUT_BITMAP_TIMES_ROMAN_24
const float size_h = 24.0;
#else
#define FONT_KIND GLUT_BITMAP_HELVETICA_18
const float size_h = 18.0;
#endif

unsigned char image[panel_h][panel_w][3];

GLfloat fg_color[3];
GLfloat bg_color[3];

char file_name[256];

void parse(char *string)
  //  before : Magnetic\\nField\0
  //   after : Magnetic\nField\0
{
    char *p, *q;

    for (p = string; *p != '\0'; p++) {
	if (*p == '\\' && *(p + 1) == 'n') {
	    *p = '\n';
	    q = p + 1;
	    do {		// Shift 1 character to left.
		*q = *(q + 1);
		q++;
	    } while (*q != '\0');
	}
    }
}

void display_func(void)
{

    char string[60];
    int stcut[5];
    int i, j, k, i0;
    char *st;
    GLfloat val[10][4];
    FILE *fp;

    stcut[0] = 0;
    j = 0;
    i0 = -1;

    glRasterPos2f(0.0, 0.0);

    st = strings;

    glRasterPos2f(0.0, 0.0);

    for (i = 0; i < strlen(strings); i++) {
	i0++;
	glutBitmapCharacter(FONT_KIND, *st);
	glGetFloatv(GL_CURRENT_RASTER_POSITION, val[0]);

	if (strings[i] == '\n' || val[0][0] >= (panel_w - 1.0)) {
	    stcut[++j] = i0;

	    if (strings[i] == '\n')
		i0--;

	    glRasterPos2f(0.0, 0.0);

	}

	st++;
    }

    i = 0;
    for (k = 0; k < strlen(strings); k++) {
	if (strings[k] != '\n') {
	    string[i] = strings[k];
	    string[i + 1] = '\0';
	    i++;
	}
    }

    glClearColor(bg_color[0], bg_color[1], bg_color[2], 0.0f);
    glClear(GL_COLOR_BUFFER_BIT);
    glColor3fv(fg_color);

    st = string;
    GLfloat rast_y = 0.0;

    stcut[++j] = (int) strlen(string);

    for (int j0 = 0; j0 < j; j0++) {

	glRasterPos2f(0.0, rast_y);

	for (k = stcut[j0]; k < stcut[j0 + 1]; k++) {
	    if(*st != '\\')
	      glutBitmapCharacter(FONT_KIND, *st);
	    st++;
	}

	glGetFloatv(GL_CURRENT_RASTER_POSITION, val[j0]);
	rast_y += size_h;

    }


    glClear(GL_COLOR_BUFFER_BIT);
    st = string;

    rast_y = (panel_h - rast_y) / 2.0 + size_h * (j - 1);
    float rast_x;


    for (int j0 = 0; j0 < j; j0++) {
	rast_x = (panel_w - val[j0][0]) / 2.0;

	if (rast_x <= 0.0)
	    rast_x = 0.0;

	glRasterPos2f(rast_x, rast_y + 3.0);

	for (k = stcut[j0]; k < stcut[j0 + 1]; k++) {
	    if(*st != '\\')
	     glutBitmapCharacter(FONT_KIND, *st);
	    st++;
	}

	rast_y -= size_h;

    }

    glFinish();

    glReadPixels(0, 0, panel_w, panel_h, GL_RGB, GL_UNSIGNED_BYTE,
		 &image[0][0][0]);

    if ((fp = fopen(file_name, "wb")) == NULL) {
	printf("File Open Error:%s\n",file_name);
	exit(0);
    }

    fwrite(&image[0][0][0], sizeof(unsigned char),
	   panel_w * panel_h * 3, fp);

    fclose(fp);

//	char ppmfile[256];
//	sprintf(ppmfile,"%s.ppm",file_name);
//    if ((fp = fopen(ppmfile, "wb")) == NULL) {
//	printf("File Open Error:%s\n",file_name);
//	exit(0);
//    }

//    fprintf(fp, "P6\n%d %d\n255\n", panel_w, panel_h);
//    fwrite(&image[0][0][0], sizeof(unsigned char),
//	   panel_w * panel_h * 3, fp);

//    fclose(fp);

    exit(1);
}

void resize_func(int w, int h)
{
    glViewport(0, 0, w, h);
    glLoadIdentity();
    glOrtho(0.0, (GLfloat) w, 0.0, (GLfloat) h, 0.0, 1.0);
}


int main(int argc, char **argv)
{

    long fg, bg;

	// ------- Usage ------------------------------------------
    // tex_maker words color(words) color(background) file_name
    // --------------------------------------------------------

    strcpy(strings, argv[1]);
//    printf("%s -> ", strings);

    fg = strtol(argv[2], NULL, 0);
    bg = strtol(argv[3], NULL, 0);

    fg_color[0] = (float) ((0xff0000 & fg) >> 16);
    fg_color[1] = (float) ((0x00ff00 & fg) >> 8);
    fg_color[2] = (float) (0x0000ff & fg);

    bg_color[0] = (float) ((0xff0000 & bg) >> 16);
    bg_color[1] = (float) ((0x00ff00 & bg) >> 8);
    bg_color[2] = (float) (0x0000ff & bg);

    for(int i=0;i<3;i++){
	fg_color[i] /= 255.0;
	bg_color[i] /= 255.0;
    }

//    printf("Words :%f, %f, %f\n",fg_color[0],fg_color[1],fg_color[2]);
//    printf("BackGround :%f, %f, %f\n",bg_color[0],bg_color[1],bg_color[2]);

//    printf("%s\n", argv[1]);
//    printf("%s\n", strings);
    parse(strings);
//    printf("%s\n", strings);

    strcpy(file_name, argv[4]);
    memset(&image[0][0][0],0,panel_w*panel_h*3);
    glutInit(&argc, argv);
    glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB);
    glutInitWindowSize(panel_w, panel_h);
    glutInitWindowPosition( 0, 0 );
    glutCreateWindow("Making Texture");
    glutReshapeFunc(resize_func);
    glutDisplayFunc(display_func);

    glutMainLoop();
    return 0;
}
