//
//
// words.c++
//
//    Nobuaki Ohno   2005.11
//
//    A set of Data(Stroke Font) and Functions 
//      to display some messages and figures in CAVE room.
//
// Please read the file "LICENCE_ja.txt"(in Japanese) or "LICENCE_en.txt" (in English)
// before you use this software. 


#include "./vfive.h"

void cave_message::write_message(float scale, char *words, float *space, float *vspace)
{
//    printf("%s %d\n", words,cont);
    int i, j, k, n_words;
    int c, wn, length;
    float total_space = *space;
    float total_vspace = *vspace;

    n_words = (int)strlen(words);

    glLineWidth(2.0);
    glPushMatrix();

    glScalef(scale, scale, scale);

    for (i = 0; i < n_words; i++) {

	c = words[i];

	if (c >= '0' && c <= '9')
	    wn = c - '0' + 61;
	else if (c >= 'a' && c <= 'z')
	    wn = c - 'a' + 26;
	else if (c >= 'A' && c <= 'Z')
	    wn = c - 'A';
	else {

	    switch (c) {

	    case '.':
		wn = 52;
		break;

	    case ',':
		wn = 53;
		break;

	    case '\'':
		wn = 54;
		break;

	    case ':':
		wn = 55;
		break;

	    case ';':
		wn = 56;
		break;

	    case '!':
		wn = 57;
		break;

	    case '?':
		wn = 58;
		break;

	    case '#':
		wn = 59;
		break;

	    case '_':
		wn = 60;
		break;

	    case '+':
		wn = 71;
		break;

	    case '-':
		wn = 72;
		break;

	    case '/':
		wn = 73;
		break;

	    case '*':
		wn = 74;
		break;

	    case '=':
		wn = 75;
		break;

	    case '[':
		wn = 76;
		break;

	    case ']':
		wn = 77;
		break;

	    case '(':
		wn = 78;
		break;

	    case ')':
		wn = 79;
		break;

	    case '<':
		wn = 80;
		break;

	    case '>':
		wn = 81;
		break;

	    case '|':
		wn = 82;
		break;

	    case '\"':
		wn = 83;
		break;

	    case '$':
		wn = 84;
		break;

	    case '%':
		wn = 85;
		break;

	    case '&':
		wn = 86;
		break;

	    case '~':
		wn = 87;
		break;

	    case '^':
		wn = 88;
		break;

	    case '\\':
		wn = 89;
		break;

	    case '@':
		wn = 90;
		break;

	    case '{':
		wn = 91;
		break;

	    case '}':
		wn = 92;
		break;

	    case '`':
		wn = 93;
		break;

	    case ' ':
		wn = 94;
		break;

	    case '\n':
		wn = 95;
		break;

	    default:
		wn = 93;
		break;

	    }


	}


	length = 0;

	for (j = 0; j < word[wn].pen_num; j++) {
	    glBegin(GL_LINE_STRIP);
	    for (k = length; k < length + word[wn].v_length[j]; k++) {
		glVertex3f(total_space + word[wn].vertex_data[k][0],
			   0.0, word[wn].vertex_data[k][1] - total_vspace);
	    }
	    glEnd();
	    length = length + word[wn].v_length[j];
	}

	if (wn == 95) {
	    total_space = 0.0;
	    total_vspace += word[wn].space;
	} else {
	    total_space += word[wn].space;
	}

    }
    glPopMatrix();
    glLineWidth(1.0);

    *space = total_space;
    *vspace = total_vspace;

}


/////////////////////////
// Initialization
// Setting Font data
//-----------------------
cave_message::cave_message()
{
    /* A */
    word[0].pen_num = 2;

    word[0].v_length[0] = 4;
    word[0].v_length[1] = 2;

    word[0].space = 0.5;

    word[0].vertex_data[0][0] = 0.0;
    word[0].vertex_data[0][1] = 0.0;

    word[0].vertex_data[1][0] = 0.1;
    word[0].vertex_data[1][1] = 0.8;

    word[0].vertex_data[2][0] = 0.3;
    word[0].vertex_data[2][1] = 0.8;

    word[0].vertex_data[3][0] = 0.4;
    word[0].vertex_data[3][1] = 0.0;


    word[0].vertex_data[4][0] = 0.05;
    word[0].vertex_data[4][1] = 0.4;

    word[0].vertex_data[5][0] = 0.35;
    word[0].vertex_data[5][1] = 0.4;


    /* B */
    word[1].pen_num = 1;

    word[1].v_length[0] = 11;

    word[1].space = 0.5;

    word[1].vertex_data[0][0] = 0.0;
    word[1].vertex_data[0][1] = 0.45;

    word[1].vertex_data[1][0] = 0.3;
    word[1].vertex_data[1][1] = 0.45;

    word[1].vertex_data[2][0] = 0.35;
    word[1].vertex_data[2][1] = 0.5;

    word[1].vertex_data[3][0] = 0.35;
    word[1].vertex_data[3][1] = 0.75;

    word[1].vertex_data[4][0] = 0.25;
    word[1].vertex_data[4][1] = 0.8;

    word[1].vertex_data[5][0] = 0.0;
    word[1].vertex_data[5][1] = 0.8;

    word[1].vertex_data[6][0] = 0.0;
    word[1].vertex_data[6][1] = 0.0;

    word[1].vertex_data[7][0] = 0.325;
    word[1].vertex_data[7][1] = 0.0;

    word[1].vertex_data[8][0] = 0.4;
    word[1].vertex_data[8][1] = 0.1;

    word[1].vertex_data[9][0] = 0.4;
    word[1].vertex_data[9][1] = 0.35;

    word[1].vertex_data[10][0] = 0.3;
    word[1].vertex_data[10][1] = 0.45;

    /* C */
    word[2].pen_num = 1;

    word[2].v_length[0] = 8;

    word[2].space = 0.5;

    word[2].vertex_data[0][0] = 0.4;
    word[2].vertex_data[0][1] = 0.125;

    word[2].vertex_data[1][0] = 0.325;
    word[2].vertex_data[1][1] = 0.0;

    word[2].vertex_data[2][0] = 0.075;
    word[2].vertex_data[2][1] = 0.0;

    word[2].vertex_data[3][0] = 0.0;
    word[2].vertex_data[3][1] = 0.125;

    word[2].vertex_data[4][0] = 0.0;
    word[2].vertex_data[4][1] = 0.675;

    word[2].vertex_data[5][0] = 0.075;
    word[2].vertex_data[5][1] = 0.8;

    word[2].vertex_data[6][0] = 0.325;
    word[2].vertex_data[6][1] = 0.8;

    word[2].vertex_data[7][0] = 0.4;
    word[2].vertex_data[7][1] = 0.675;


    /* D */
    word[3].pen_num = 1;

    word[3].v_length[0] = 7;

    word[3].space = 0.5;

    word[3].vertex_data[0][0] = 0.0;
    word[3].vertex_data[0][1] = 0.0;

    word[3].vertex_data[1][0] = 0.0;
    word[3].vertex_data[1][1] = 0.8;

    word[3].vertex_data[2][0] = 0.25;
    word[3].vertex_data[2][1] = 0.8;

    word[3].vertex_data[3][0] = 0.4;
    word[3].vertex_data[3][1] = 0.6;

    word[3].vertex_data[4][0] = 0.4;
    word[3].vertex_data[4][1] = 0.2;

    word[3].vertex_data[5][0] = 0.25;
    word[3].vertex_data[5][1] = 0.0;

    word[3].vertex_data[6][0] = 0.0;
    word[3].vertex_data[6][1] = 0.0;


    /* E */
    word[4].pen_num = 2;

    word[4].v_length[0] = 4;
    word[4].v_length[1] = 2;

    word[4].space = 0.5;

    word[4].vertex_data[0][0] = 0.4;
    word[4].vertex_data[0][1] = 0.8;

    word[4].vertex_data[1][0] = 0.0;
    word[4].vertex_data[1][1] = 0.8;

    word[4].vertex_data[2][0] = 0.0;
    word[4].vertex_data[2][1] = 0.0;

    word[4].vertex_data[3][0] = 0.4;
    word[4].vertex_data[3][1] = 0.0;

    word[4].vertex_data[4][0] = 0.0;
    word[4].vertex_data[4][1] = 0.4;

    word[4].vertex_data[5][0] = 0.3;
    word[4].vertex_data[5][1] = 0.4;


    /* F */
    word[5].pen_num = 2;

    word[5].v_length[0] = 3;
    word[5].v_length[1] = 2;

    word[5].space = 0.5;

    word[5].vertex_data[0][0] = 0.4;
    word[5].vertex_data[0][1] = 0.8;

    word[5].vertex_data[1][0] = 0.0;
    word[5].vertex_data[1][1] = 0.8;

    word[5].vertex_data[2][0] = 0.0;
    word[5].vertex_data[2][1] = 0.0;

    word[5].vertex_data[3][0] = 0.0;
    word[5].vertex_data[3][1] = 0.42;

    word[5].vertex_data[4][0] = 0.3;
    word[5].vertex_data[4][1] = 0.42;


    /* G */
    word[6].pen_num = 1;

    word[6].v_length[0] = 10;

    word[6].space = 0.5;

    word[6].vertex_data[0][0] = 0.2;
    word[6].vertex_data[0][1] = 0.35;

    word[6].vertex_data[1][0] = 0.4;
    word[6].vertex_data[1][1] = 0.35;

    word[6].vertex_data[2][0] = 0.4;
    word[6].vertex_data[2][1] = 0.15;

    word[6].vertex_data[3][0] = 0.325;
    word[6].vertex_data[3][1] = 0.0;

    word[6].vertex_data[4][0] = 0.075;
    word[6].vertex_data[4][1] = 0.0;

    word[6].vertex_data[5][0] = 0.0;
    word[6].vertex_data[5][1] = 0.15;

    word[6].vertex_data[6][0] = 0.0;
    word[6].vertex_data[6][1] = 0.65;

    word[6].vertex_data[7][0] = 0.075;
    word[6].vertex_data[7][1] = 0.8;

    word[6].vertex_data[8][0] = 0.325;
    word[6].vertex_data[8][1] = 0.8;

    word[6].vertex_data[9][0] = 0.4;
    word[6].vertex_data[9][1] = 0.65;


    /* H */
    word[7].pen_num = 3;

    word[7].v_length[0] = 2;
    word[7].v_length[1] = 2;
    word[7].v_length[2] = 2;

    word[7].space = 0.5;

    word[7].vertex_data[0][0] = 0.0;
    word[7].vertex_data[0][1] = 0.0;

    word[7].vertex_data[1][0] = 0.0;
    word[7].vertex_data[1][1] = 0.8;

    word[7].vertex_data[2][0] = 0.0;
    word[7].vertex_data[2][1] = 0.4;

    word[7].vertex_data[3][0] = 0.4;
    word[7].vertex_data[3][1] = 0.4;

    word[7].vertex_data[4][0] = 0.4;
    word[7].vertex_data[4][1] = 0.0;

    word[7].vertex_data[5][0] = 0.4;
    word[7].vertex_data[5][1] = 0.8;


    /* I */
    word[8].pen_num = 3;

    word[8].v_length[0] = 2;
    word[8].v_length[1] = 2;
    word[8].v_length[2] = 2;

    word[8].space = 0.3;

    word[8].vertex_data[0][0] = 0.1;
    word[8].vertex_data[0][1] = 0.0;

    word[8].vertex_data[1][0] = 0.1;
    word[8].vertex_data[1][1] = 0.8;

    word[8].vertex_data[2][0] = 0.0;
    word[8].vertex_data[2][1] = 0.8;

    word[8].vertex_data[3][0] = 0.2;
    word[8].vertex_data[3][1] = 0.8;

    word[8].vertex_data[4][0] = 0.0;
    word[8].vertex_data[4][1] = 0.0;

    word[8].vertex_data[5][0] = 0.2;
    word[8].vertex_data[5][1] = 0.0;

    /* J */
    word[9].pen_num = 2;

    word[9].v_length[0] = 5;

    word[9].space = 0.45;

    word[9].vertex_data[0][0] = 0.35;
    word[9].vertex_data[0][1] = 0.8;

    word[9].vertex_data[1][0] = 0.35;
    word[9].vertex_data[1][1] = 0.15;

    word[9].vertex_data[2][0] = 0.25;
    word[9].vertex_data[2][1] = 0.0;

    word[9].vertex_data[3][0] = 0.1;
    word[9].vertex_data[3][1] = 0.0;

    word[9].vertex_data[4][0] = 0.0;
    word[9].vertex_data[4][1] = 0.15;



    /* K */
    word[10].pen_num = 3;

    word[10].v_length[0] = 2;
    word[10].v_length[1] = 2;
    word[10].v_length[2] = 3;

    word[10].space = 0.5;

    word[10].vertex_data[0][0] = 0.0;
    word[10].vertex_data[0][1] = 0.8;

    word[10].vertex_data[1][0] = 0.0;
    word[10].vertex_data[1][1] = 0.0;


    word[10].vertex_data[2][0] = 0.15;
    word[10].vertex_data[2][1] = 0.45;

    word[10].vertex_data[3][0] = 0.4;
    word[10].vertex_data[3][1] = 0.8;


    word[10].vertex_data[4][0] = 0.0;
    word[10].vertex_data[4][1] = 0.45;

    word[10].vertex_data[5][0] = 0.15;
    word[10].vertex_data[5][1] = 0.45;

    word[10].vertex_data[6][0] = 0.4;
    word[10].vertex_data[6][1] = 0.0;

    /* L */
    word[11].pen_num = 1;

    word[11].v_length[0] = 3;

    word[11].space = 0.5;

    word[11].vertex_data[0][0] = 0.0;
    word[11].vertex_data[0][1] = 0.8;

    word[11].vertex_data[1][0] = 0.0;
    word[11].vertex_data[1][1] = 0.0;

    word[11].vertex_data[2][0] = 0.4;
    word[11].vertex_data[2][1] = 0.0;

    /* M */
    word[12].pen_num = 1;

    word[12].v_length[0] = 5;

    word[12].space = 0.6;

    word[12].vertex_data[0][0] = 0.0;
    word[12].vertex_data[0][1] = 0.0;

    word[12].vertex_data[1][0] = 0.0;
    word[12].vertex_data[1][1] = 0.8;

    word[12].vertex_data[2][0] = 0.25;
    word[12].vertex_data[2][1] = 0.3;

    word[12].vertex_data[3][0] = 0.5;
    word[12].vertex_data[3][1] = 0.8;

    word[12].vertex_data[4][0] = 0.5;
    word[12].vertex_data[4][1] = 0.0;

    /* N */
    word[13].pen_num = 1;

    word[13].v_length[0] = 4;

    word[13].space = 0.5;

    word[13].vertex_data[0][0] = 0.0;
    word[13].vertex_data[0][1] = 0.0;

    word[13].vertex_data[1][0] = 0.0;
    word[13].vertex_data[1][1] = 0.8;

    word[13].vertex_data[2][0] = 0.4;
    word[13].vertex_data[2][1] = 0.0;

    word[13].vertex_data[3][0] = 0.4;
    word[13].vertex_data[3][1] = 0.8;

    /* O */
    word[14].pen_num = 1;

    word[14].v_length[0] = 9;

    word[14].space = 0.5;

    word[14].vertex_data[0][0] = 0.325;
    word[14].vertex_data[0][1] = 0.8;

    word[14].vertex_data[1][0] = 0.4;
    word[14].vertex_data[1][1] = 0.7;

    word[14].vertex_data[2][0] = 0.4;
    word[14].vertex_data[2][1] = 0.1;

    word[14].vertex_data[3][0] = 0.325;
    word[14].vertex_data[3][1] = 0.0;

    word[14].vertex_data[4][0] = 0.075;
    word[14].vertex_data[4][1] = 0.0;

    word[14].vertex_data[5][0] = 0.0;
    word[14].vertex_data[5][1] = 0.1;

    word[14].vertex_data[6][0] = 0.0;
    word[14].vertex_data[6][1] = 0.7;

    word[14].vertex_data[7][0] = 0.075;
    word[14].vertex_data[7][1] = 0.8;

    word[14].vertex_data[8][0] = 0.325;
    word[14].vertex_data[8][1] = 0.8;



    /* P */
    word[15].pen_num = 1;

    word[15].v_length[0] = 5;

    word[15].space = 0.45;

    word[15].vertex_data[0][0] = 0.0;
    word[15].vertex_data[0][1] = 0.0;

    word[15].vertex_data[1][0] = 0.0;
    word[15].vertex_data[1][1] = 0.8;

    word[15].vertex_data[2][0] = 0.35;
    word[15].vertex_data[2][1] = 0.8;

    word[15].vertex_data[3][0] = 0.35;
    word[15].vertex_data[3][1] = 0.4;

    word[15].vertex_data[4][0] = 0.0;
    word[15].vertex_data[4][1] = 0.4;

    /* Q */
    word[16].pen_num = 2;

    word[16].v_length[0] = 9;
    word[16].v_length[1] = 2;

    word[16].space = 0.5;

    word[16].vertex_data[0][0] = 0.325;
    word[16].vertex_data[0][1] = 0.8;

    word[16].vertex_data[1][0] = 0.4;
    word[16].vertex_data[1][1] = 0.65;

    word[16].vertex_data[2][0] = 0.4;
    word[16].vertex_data[2][1] = 0.15;

    word[16].vertex_data[3][0] = 0.325;
    word[16].vertex_data[3][1] = 0.0;

    word[16].vertex_data[4][0] = 0.075;
    word[16].vertex_data[4][1] = 0.0;

    word[16].vertex_data[5][0] = 0.0;
    word[16].vertex_data[5][1] = 0.15;

    word[16].vertex_data[6][0] = 0.0;
    word[16].vertex_data[6][1] = 0.65;

    word[16].vertex_data[7][0] = 0.075;
    word[16].vertex_data[7][1] = 0.8;

    word[16].vertex_data[8][0] = 0.325;
    word[16].vertex_data[8][1] = 0.8;


    word[16].vertex_data[9][0] = 0.2;
    word[16].vertex_data[9][1] = 0.3;

    word[16].vertex_data[10][0] = 0.4;
    word[16].vertex_data[10][1] = 0.0;


    /* R */
    word[17].pen_num = 2;

    word[17].v_length[0] = 5;
    word[17].v_length[1] = 2;

    word[17].space = 0.5;

    word[17].vertex_data[0][0] = 0.0;
    word[17].vertex_data[0][1] = 0.0;

    word[17].vertex_data[1][0] = 0.0;
    word[17].vertex_data[1][1] = 0.8;

    word[17].vertex_data[2][0] = 0.35;
    word[17].vertex_data[2][1] = 0.8;

    word[17].vertex_data[3][0] = 0.35;
    word[17].vertex_data[3][1] = 0.4;

    word[17].vertex_data[4][0] = 0.0;
    word[17].vertex_data[4][1] = 0.4;

    word[17].vertex_data[5][0] = 0.275;
    word[17].vertex_data[5][1] = 0.4;

    word[17].vertex_data[6][0] = 0.4;
    word[17].vertex_data[6][1] = 0.0;


    /* S */
    word[18].pen_num = 1;

    word[18].v_length[0] = 10;

    word[18].space = 0.5;

    word[18].vertex_data[0][0] = 0.4;
    word[18].vertex_data[0][1] = 0.65;

    word[18].vertex_data[1][0] = 0.3;
    word[18].vertex_data[1][1] = 0.8;

    word[18].vertex_data[2][0] = 0.1;
    word[18].vertex_data[2][1] = 0.8;

    word[18].vertex_data[3][0] = 0.0;
    word[18].vertex_data[3][1] = 0.65;

    word[18].vertex_data[4][0] = 0.0;
    word[18].vertex_data[4][1] = 0.45;

    word[18].vertex_data[5][0] = 0.4;
    word[18].vertex_data[5][1] = 0.35;

    word[18].vertex_data[6][0] = 0.4;
    word[18].vertex_data[6][1] = 0.15;

    word[18].vertex_data[7][0] = 0.3;
    word[18].vertex_data[7][1] = 0.0;

    word[18].vertex_data[8][0] = 0.1;
    word[18].vertex_data[8][1] = 0.0;

    word[18].vertex_data[9][0] = 0.0;
    word[18].vertex_data[9][1] = 0.15;

    /* T */
    word[19].pen_num = 2;

    word[19].v_length[0] = 2;
    word[19].v_length[1] = 2;

    word[19].space = 0.5;

    word[19].vertex_data[0][0] = 0.0;
    word[19].vertex_data[0][1] = 0.8;

    word[19].vertex_data[1][0] = 0.4;
    word[19].vertex_data[1][1] = 0.8;

    word[19].vertex_data[2][0] = 0.2;
    word[19].vertex_data[2][1] = 0.8;

    word[19].vertex_data[3][0] = 0.2;
    word[19].vertex_data[3][1] = 0.0;

    /* U */
    word[20].pen_num = 1;

    word[20].v_length[0] = 6;

    word[20].space = 0.5;

    word[20].vertex_data[0][0] = 0.0;
    word[20].vertex_data[0][1] = 0.8;

    word[20].vertex_data[1][0] = 0.0;
    word[20].vertex_data[1][1] = 0.2;

    word[20].vertex_data[2][0] = 0.1;
    word[20].vertex_data[2][1] = 0.0;

    word[20].vertex_data[3][0] = 0.3;
    word[20].vertex_data[3][1] = 0.0;

    word[20].vertex_data[4][0] = 0.4;
    word[20].vertex_data[4][1] = 0.2;

    word[20].vertex_data[5][0] = 0.4;
    word[20].vertex_data[5][1] = 0.8;

    /* V */
    word[21].pen_num = 1;

    word[21].v_length[0] = 3;

    word[21].space = 0.5;

    word[21].vertex_data[0][0] = 0.0;
    word[21].vertex_data[0][1] = 0.8;

    word[21].vertex_data[1][0] = 0.2;
    word[21].vertex_data[1][1] = 0.0;

    word[21].vertex_data[2][0] = 0.4;
    word[21].vertex_data[2][1] = 0.8;

    /* W */
    word[22].pen_num = 1;

    word[22].v_length[0] = 5;

    word[22].space = 0.6;

    word[22].vertex_data[0][0] = 0.0;
    word[22].vertex_data[0][1] = 0.8;

    word[22].vertex_data[1][0] = 0.125;
    word[22].vertex_data[1][1] = 0.0;

    word[22].vertex_data[2][0] = 0.25;
    word[22].vertex_data[2][1] = 0.55;

    word[22].vertex_data[3][0] = 0.375;
    word[22].vertex_data[3][1] = 0.0;

    word[22].vertex_data[4][0] = 0.5;
    word[22].vertex_data[4][1] = 0.8;

    /* X */
    word[23].pen_num = 2;

    word[23].v_length[0] = 2;
    word[23].v_length[1] = 2;

    word[23].space = 0.5;

    word[23].vertex_data[0][0] = 0.0;
    word[23].vertex_data[0][1] = 0.8;

    word[23].vertex_data[1][0] = 0.4;
    word[23].vertex_data[1][1] = 0.0;

    word[23].vertex_data[2][0] = 0.0;
    word[23].vertex_data[2][1] = 0.0;

    word[23].vertex_data[3][0] = 0.4;
    word[23].vertex_data[3][1] = 0.8;


    /* Y */
    word[24].pen_num = 2;

    word[24].v_length[0] = 3;
    word[24].v_length[1] = 2;

    word[24].space = 0.5;

    word[24].vertex_data[0][0] = 0.0;
    word[24].vertex_data[0][1] = 0.8;

    word[24].vertex_data[1][0] = 0.2;
    word[24].vertex_data[1][1] = 0.45;

    word[24].vertex_data[2][0] = 0.2;
    word[24].vertex_data[2][1] = 0.0;

    word[24].vertex_data[3][0] = 0.4;
    word[24].vertex_data[3][1] = 0.8;

    word[24].vertex_data[4][0] = 0.2;
    word[24].vertex_data[4][1] = 0.45;


    /* Z */
    word[25].pen_num = 1;

    word[25].v_length[0] = 4;

    word[25].space = 0.5;

    word[25].vertex_data[0][0] = 0.0;
    word[25].vertex_data[0][1] = 0.8;

    word[25].vertex_data[1][0] = 0.4;
    word[25].vertex_data[1][1] = 0.8;

    word[25].vertex_data[2][0] = 0.0;
    word[25].vertex_data[2][1] = 0.0;

    word[25].vertex_data[3][0] = 0.4;
    word[25].vertex_data[3][1] = 0.0;

    /* . */
    word[52].pen_num = 1;

    word[52].v_length[0] = 5;

    word[52].space = 0.2;

    word[52].vertex_data[0][0] = 0.05;
    word[52].vertex_data[0][1] = 0.0;

    word[52].vertex_data[1][0] = 0.05;
    word[52].vertex_data[1][1] = 0.05;

    word[52].vertex_data[2][0] = 0.1;
    word[52].vertex_data[2][1] = 0.05;

    word[52].vertex_data[3][0] = 0.1;
    word[52].vertex_data[3][1] = 0.0;

    word[52].vertex_data[4][0] = 0.05;
    word[52].vertex_data[4][1] = 0.0;

    /* , */
    word[53].pen_num = 1;

    word[53].v_length[0] = 4;

    word[53].space = 0.2;

    word[53].vertex_data[0][0] = 0.05;
    word[53].vertex_data[0][1] = 0.05;

    word[53].vertex_data[1][0] = 0.1;
    word[53].vertex_data[1][1] = 0.05;

    word[53].vertex_data[2][0] = 0.1;
    word[53].vertex_data[2][1] = 0.0;

    word[53].vertex_data[3][0] = 0.05;
    word[53].vertex_data[3][1] = -0.1;



    /* ' */
    word[54].pen_num = 1;

    word[54].v_length[0] = 2;

    word[54].space = 0.2;

    word[54].vertex_data[0][0] = 0.1;
    word[54].vertex_data[0][1] = 0.8;

    word[54].vertex_data[1][0] = 0.05;
    word[54].vertex_data[1][1] = 0.65;

    /* : */
    word[55].pen_num = 2;

    word[55].v_length[0] = 5;
    word[55].v_length[1] = 5;

    word[55].space = 0.25;

    word[55].vertex_data[0][0] = 0.075;
    word[55].vertex_data[0][1] = 0.25;

    word[55].vertex_data[1][0] = 0.075;
    word[55].vertex_data[1][1] = 0.15;

    word[55].vertex_data[2][0] = 0.175;
    word[55].vertex_data[2][1] = 0.15;

    word[55].vertex_data[3][0] = 0.175;
    word[55].vertex_data[3][1] = 0.25;

    word[55].vertex_data[4][0] = 0.075;
    word[55].vertex_data[4][1] = 0.25;




    word[55].vertex_data[5][0] = 0.075;
    word[55].vertex_data[5][1] = 0.65;

    word[55].vertex_data[6][0] = 0.075;
    word[55].vertex_data[6][1] = 0.55;

    word[55].vertex_data[7][0] = 0.175;
    word[55].vertex_data[7][1] = 0.55;

    word[55].vertex_data[8][0] = 0.175;
    word[55].vertex_data[8][1] = 0.65;

    word[55].vertex_data[9][0] = 0.075;
    word[55].vertex_data[9][1] = 0.65;

    /* ; */
    word[56].pen_num = 2;

    word[56].v_length[0] = 2;
    word[56].v_length[1] = 3;

    word[56].space = 0.2;


    word[56].vertex_data[0][0] = 0.075;
    word[56].vertex_data[0][1] = 0.65;

    word[56].vertex_data[1][0] = 0.075;
    word[56].vertex_data[1][1] = 0.55;


    word[56].vertex_data[2][0] = 0.075;
    word[56].vertex_data[2][1] = 0.25;

    word[56].vertex_data[3][0] = 0.075;
    word[56].vertex_data[3][1] = 0.15;

    word[56].vertex_data[4][0] = 0.025;
    word[56].vertex_data[4][1] = 0.05;



    /* ! */
    word[57].pen_num = 2;

    word[57].v_length[0] = 2;
    word[57].v_length[1] = 2;

    word[57].space = 0.3;

    word[57].vertex_data[0][0] = 0.075;
    word[57].vertex_data[0][1] = 0.1;

    word[57].vertex_data[1][0] = 0.075;
    word[57].vertex_data[1][1] = 0.0;

    word[57].vertex_data[2][0] = 0.2;
    word[57].vertex_data[2][1] = 0.8;

    word[57].vertex_data[3][0] = 0.075;
    word[57].vertex_data[3][1] = 0.2;


    /* ? */
    word[58].pen_num = 2;

    word[58].v_length[0] = 9;
    word[58].v_length[1] = 2;

    word[58].space = 0.5;

    word[58].vertex_data[0][0] = 0.1;
    word[58].vertex_data[0][1] = 0.4;

    word[58].vertex_data[1][0] = 0.0;
    word[58].vertex_data[1][1] = 0.5;

    word[58].vertex_data[2][0] = 0.0;
    word[58].vertex_data[2][1] = 0.7;

    word[58].vertex_data[3][0] = 0.1;
    word[58].vertex_data[3][1] = 0.8;

    word[58].vertex_data[4][0] = 0.3;
    word[58].vertex_data[4][1] = 0.8;

    word[58].vertex_data[5][0] = 0.4;
    word[58].vertex_data[5][1] = 0.7;

    word[58].vertex_data[6][0] = 0.4;
    word[58].vertex_data[6][1] = 0.5;

    word[58].vertex_data[7][0] = 0.2;
    word[58].vertex_data[7][1] = 0.3;

    word[58].vertex_data[8][0] = 0.2;
    word[58].vertex_data[8][1] = 0.18;

    word[58].vertex_data[9][0] = 0.2;
    word[58].vertex_data[9][1] = 0.1;

    word[58].vertex_data[10][0] = 0.2;
    word[58].vertex_data[10][1] = 0.0;


    /* # */
    word[59].pen_num = 4;

    word[59].v_length[0] = 2;
    word[59].v_length[1] = 2;
    word[59].v_length[2] = 2;
    word[59].v_length[3] = 2;

    word[59].space = 0.45;

    word[59].vertex_data[0][0] = 0.0;
    word[59].vertex_data[0][1] = 0.35;

    word[59].vertex_data[1][0] = 0.4;
    word[59].vertex_data[1][1] = 0.35;

    word[59].vertex_data[2][0] = 0.0;
    word[59].vertex_data[2][1] = 0.45;

    word[59].vertex_data[3][0] = 0.4;
    word[59].vertex_data[3][1] = 0.45;


    word[59].vertex_data[4][0] = 0.15;
    word[59].vertex_data[4][1] = 0.65;

    word[59].vertex_data[5][0] = 0.05;
    word[59].vertex_data[5][1] = 0.15;


    word[59].vertex_data[6][0] = 0.25;
    word[59].vertex_data[6][1] = 0.65;

    word[59].vertex_data[7][0] = 0.15;
    word[59].vertex_data[7][1] = 0.15;

    /* _ */
    word[60].pen_num = 1;

    word[60].v_length[0] = 2;

    word[60].space = 0.45;

    word[60].vertex_data[0][0] = 0.0;
    word[60].vertex_data[0][1] = 0.0;

    word[60].vertex_data[1][0] = 0.3;
    word[60].vertex_data[1][1] = 0.0;

    /* 0 */
    word[61].pen_num = 1;

    word[61].v_length[0] = 6;

    word[61].space = 0.45;

    word[61].vertex_data[0][0] = 0.35;
    word[61].vertex_data[0][1] = 0.8;

    word[61].vertex_data[1][0] = 0.35;
    word[61].vertex_data[1][1] = 0.0;

    word[61].vertex_data[2][0] = 0.0;
    word[61].vertex_data[2][1] = 0.0;

    word[61].vertex_data[3][0] = 0.0;
    word[61].vertex_data[3][1] = 0.8;

    word[61].vertex_data[4][0] = 0.35;
    word[61].vertex_data[4][1] = 0.8;

    word[61].vertex_data[5][0] = 0.0;
    word[61].vertex_data[5][1] = 0.0;

    /* 1 */
    word[62].pen_num = 1;

    word[62].v_length[0] = 3;

    word[62].space = 0.3;

    word[62].vertex_data[0][0] = 0.0;
    word[62].vertex_data[0][1] = 0.45;

    word[62].vertex_data[1][0] = 0.15;
    word[62].vertex_data[1][1] = 0.8;

    word[62].vertex_data[2][0] = 0.15;
    word[62].vertex_data[2][1] = 0.0;


    /* 2 */
    word[63].pen_num = 1;

    word[63].v_length[0] = 6;

    word[63].space = 0.45;

    word[63].vertex_data[0][0] = 0.0;
    word[63].vertex_data[0][1] = 0.8;

    word[63].vertex_data[1][0] = 0.35;
    word[63].vertex_data[1][1] = 0.8;

    word[63].vertex_data[2][0] = 0.35;
    word[63].vertex_data[2][1] = 0.4;

    word[63].vertex_data[3][0] = 0.0;
    word[63].vertex_data[3][1] = 0.4;

    word[63].vertex_data[4][0] = 0.0;
    word[63].vertex_data[4][1] = 0.0;

    word[63].vertex_data[5][0] = 0.35;
    word[63].vertex_data[5][1] = 0.0;

    /* 3 */
    word[64].pen_num = 2;

    word[64].v_length[0] = 4;
    word[64].v_length[1] = 3;

    word[64].space = 0.45;

    word[64].vertex_data[0][0] = 0.0;
    word[64].vertex_data[0][1] = 0.8;

    word[64].vertex_data[1][0] = 0.35;
    word[64].vertex_data[1][1] = 0.8;

    word[64].vertex_data[2][0] = 0.35;
    word[64].vertex_data[2][1] = 0.4;

    word[64].vertex_data[3][0] = 0.0;
    word[64].vertex_data[3][1] = 0.4;

    word[64].vertex_data[4][0] = 0.35;
    word[64].vertex_data[4][1] = 0.4;

    word[64].vertex_data[5][0] = 0.35;
    word[64].vertex_data[5][1] = 0.0;

    word[64].vertex_data[6][0] = 0.0;
    word[64].vertex_data[6][1] = 0.0;

    /* 4 */
    word[65].pen_num = 2;

    word[65].v_length[0] = 2;
    word[65].v_length[1] = 3;

    word[65].space = 0.45;

    word[65].vertex_data[0][0] = 0.35;
    word[65].vertex_data[0][1] = 0.0;

    word[65].vertex_data[1][0] = 0.35;
    word[65].vertex_data[1][1] = 0.8;

    word[65].vertex_data[2][0] = 0.0;
    word[65].vertex_data[2][1] = 0.8;

    word[65].vertex_data[3][0] = 0.0;
    word[65].vertex_data[3][1] = 0.4;

    word[65].vertex_data[4][0] = 0.35;
    word[65].vertex_data[4][1] = 0.4;

    /* 5 */
    word[66].pen_num = 1;

    word[66].v_length[0] = 6;

    word[66].space = 0.45;

    word[66].vertex_data[0][0] = 0.35;
    word[66].vertex_data[0][1] = 0.8;

    word[66].vertex_data[1][0] = 0.0;
    word[66].vertex_data[1][1] = 0.8;

    word[66].vertex_data[2][0] = 0.0;
    word[66].vertex_data[2][1] = 0.425;

    word[66].vertex_data[3][0] = 0.35;
    word[66].vertex_data[3][1] = 0.425;

    word[66].vertex_data[4][0] = 0.35;
    word[66].vertex_data[4][1] = 0.0;

    word[66].vertex_data[5][0] = 0.0;
    word[66].vertex_data[5][1] = 0.0;


    /* 6 */
    word[67].pen_num = 1;

    word[67].v_length[0] = 6;

    word[67].space = 0.45;

    word[67].vertex_data[0][0] = 0.35;
    word[67].vertex_data[0][1] = 0.8;

    word[67].vertex_data[1][0] = 0.0;
    word[67].vertex_data[1][1] = 0.8;

    word[67].vertex_data[2][0] = 0.0;
    word[67].vertex_data[2][1] = 0.0;

    word[67].vertex_data[3][0] = 0.35;
    word[67].vertex_data[3][1] = 0.0;

    word[67].vertex_data[4][0] = 0.35;
    word[67].vertex_data[4][1] = 0.425;

    word[67].vertex_data[5][0] = 0.0;
    word[67].vertex_data[5][1] = 0.425;

    /* 7 */
    word[68].pen_num = 1;

    word[68].v_length[0] = 3;

    word[68].space = 0.45;

    word[68].vertex_data[0][0] = 0.0;
    word[68].vertex_data[0][1] = 0.8;

    word[68].vertex_data[1][0] = 0.35;
    word[68].vertex_data[1][1] = 0.8;

    word[68].vertex_data[2][0] = 0.35;
    word[68].vertex_data[2][1] = 0.0;


    /* 8 */
    word[69].pen_num = 2;

    word[69].v_length[0] = 5;
    word[69].v_length[1] = 2;

    word[69].space = 0.45;

    word[69].vertex_data[0][0] = 0.0;
    word[69].vertex_data[0][1] = 0.0;

    word[69].vertex_data[1][0] = 0.0;
    word[69].vertex_data[1][1] = 0.8;

    word[69].vertex_data[2][0] = 0.35;
    word[69].vertex_data[2][1] = 0.8;

    word[69].vertex_data[3][0] = 0.35;
    word[69].vertex_data[3][1] = 0.0;

    word[69].vertex_data[4][0] = 0.0;
    word[69].vertex_data[4][1] = 0.0;

    word[69].vertex_data[5][0] = 0.0;
    word[69].vertex_data[5][1] = 0.4;

    word[69].vertex_data[6][0] = 0.35;
    word[69].vertex_data[6][1] = 0.4;

    /* 9 */
    word[70].pen_num = 1;

    word[70].v_length[0] = 5;

    word[70].space = 0.45;

    word[70].vertex_data[0][0] = 0.35;
    word[70].vertex_data[0][1] = 0.0;

    word[70].vertex_data[1][0] = 0.35;
    word[70].vertex_data[1][1] = 0.8;

    word[70].vertex_data[2][0] = 0.0;
    word[70].vertex_data[2][1] = 0.8;

    word[70].vertex_data[3][0] = 0.0;
    word[70].vertex_data[3][1] = 0.4;

    word[70].vertex_data[4][0] = 0.35;
    word[70].vertex_data[4][1] = 0.4;

    /* + */
    word[71].pen_num = 2;

    word[71].v_length[0] = 2;
    word[71].v_length[1] = 2;

    word[71].space = 0.6;

    word[71].vertex_data[0][0] = 0.0;
    word[71].vertex_data[0][1] = 0.4;

    word[71].vertex_data[1][0] = 0.5;
    word[71].vertex_data[1][1] = 0.4;

    word[71].vertex_data[2][0] = 0.25;
    word[71].vertex_data[2][1] = 0.65;

    word[71].vertex_data[3][0] = 0.25;
    word[71].vertex_data[3][1] = 0.15;


    /* - */
    word[72].pen_num = 1;

    word[72].v_length[0] = 2;

    word[72].space = 0.6;

    word[72].vertex_data[0][0] = 0.0;
    word[72].vertex_data[0][1] = 0.4;

    word[72].vertex_data[1][0] = 0.5;
    word[72].vertex_data[1][1] = 0.4;


    /* / */
    word[73].pen_num = 1;

    word[73].v_length[0] = 2;

    word[73].space = 0.5;

    word[73].vertex_data[0][0] = 0.4;
    word[73].vertex_data[0][1] = 0.8;

    word[73].vertex_data[1][0] = 0.0;
    word[73].vertex_data[1][1] = 0.0;


    /* * */
    word[74].pen_num = 2;

    word[74].v_length[0] = 2;
    word[74].v_length[1] = 2;

    word[74].space = 0.5;

    word[74].vertex_data[0][0] = 0.0;
    word[74].vertex_data[0][1] = 0.65;

    word[74].vertex_data[1][0] = 0.4;
    word[74].vertex_data[1][1] = 0.15;

    word[74].vertex_data[2][0] = 0.4;
    word[74].vertex_data[2][1] = 0.65;

    word[74].vertex_data[3][0] = 0.0;
    word[74].vertex_data[3][1] = 0.15;

    /* = */
    word[75].pen_num = 2;

    word[75].v_length[0] = 2;
    word[75].v_length[1] = 2;

    word[75].space = 0.55;

    word[75].vertex_data[0][0] = 0.0;
    word[75].vertex_data[0][1] = 0.5;

    word[75].vertex_data[1][0] = 0.5;
    word[75].vertex_data[1][1] = 0.5;

    word[75].vertex_data[2][0] = 0.0;
    word[75].vertex_data[2][1] = 0.3;

    word[75].vertex_data[3][0] = 0.5;
    word[75].vertex_data[3][1] = 0.3;

    /* [ */
    word[76].pen_num = 1;

    word[76].v_length[0] = 4;

    word[76].space = 0.4;

    word[76].vertex_data[0][0] = 0.2;
    word[76].vertex_data[0][1] = 0.0;

    word[76].vertex_data[1][0] = 0.0;
    word[76].vertex_data[1][1] = 0.0;

    word[76].vertex_data[2][0] = 0.0;
    word[76].vertex_data[2][1] = 0.8;

    word[76].vertex_data[3][0] = 0.2;
    word[76].vertex_data[3][1] = 0.8;

    /* ] */
    word[77].pen_num = 1;

    word[77].v_length[0] = 4;

    word[77].space = 0.4;

    word[77].vertex_data[0][0] = 0.0;
    word[77].vertex_data[0][1] = 0.0;

    word[77].vertex_data[1][0] = 0.2;
    word[77].vertex_data[1][1] = 0.0;

    word[77].vertex_data[2][0] = 0.2;
    word[77].vertex_data[2][1] = 0.8;

    word[77].vertex_data[3][0] = 0.0;
    word[77].vertex_data[3][1] = 0.8;

    /* ( */
    word[78].pen_num = 1;

    word[78].v_length[0] = 6;

    word[78].space = 0.4;

    word[78].vertex_data[0][0] = 0.2;
    word[78].vertex_data[0][1] = 0.8;

    word[78].vertex_data[1][0] = 0.1;
    word[78].vertex_data[1][1] = 0.7;

    word[78].vertex_data[2][0] = 0.0;
    word[78].vertex_data[2][1] = 0.5;

    word[78].vertex_data[3][0] = 0.0;
    word[78].vertex_data[3][1] = 0.3;

    word[78].vertex_data[4][0] = 0.1;
    word[78].vertex_data[4][1] = 0.1;

    word[78].vertex_data[5][0] = 0.2;
    word[78].vertex_data[5][1] = 0.0;

    /* ) */
    word[79].pen_num = 1;

    word[79].v_length[0] = 6;

    word[79].space = 0.4;

    word[79].vertex_data[0][0] = 0.0;
    word[79].vertex_data[0][1] = 0.8;

    word[79].vertex_data[1][0] = 0.1;
    word[79].vertex_data[1][1] = 0.7;

    word[79].vertex_data[2][0] = 0.2;
    word[79].vertex_data[2][1] = 0.5;

    word[79].vertex_data[3][0] = 0.2;
    word[79].vertex_data[3][1] = 0.3;

    word[79].vertex_data[4][0] = 0.1;
    word[79].vertex_data[4][1] = 0.1;

    word[79].vertex_data[5][0] = 0.0;
    word[79].vertex_data[5][1] = 0.0;

    /* < */
    word[80].pen_num = 1;

    word[80].v_length[0] = 3;

    word[80].space = 0.4;

    word[80].vertex_data[0][0] = 0.2;
    word[80].vertex_data[0][1] = 0.8;

    word[80].vertex_data[1][0] = 0.0;
    word[80].vertex_data[1][1] = 0.4;

    word[80].vertex_data[2][0] = 0.2;
    word[80].vertex_data[2][1] = 0.0;


    /* > */
    word[81].pen_num = 1;

    word[81].v_length[0] = 3;

    word[81].space = 0.4;

    word[81].vertex_data[0][0] = 0.0;
    word[81].vertex_data[0][1] = 0.8;

    word[81].vertex_data[1][0] = 0.2;
    word[81].vertex_data[1][1] = 0.4;

    word[81].vertex_data[2][0] = 0.0;
    word[81].vertex_data[2][1] = 0.0;

    /* | */
    word[82].pen_num = 1;

    word[82].v_length[0] = 2;

    word[82].space = 0.2;

    word[82].vertex_data[0][0] = 0.0;
    word[82].vertex_data[0][1] = 0.8;

    word[82].vertex_data[1][0] = 0.0;
    word[82].vertex_data[1][1] = 0.0;

    /* " */
    word[83].pen_num = 2;

    word[83].v_length[0] = 2;
    word[83].v_length[1] = 2;

    word[83].space = 0.25;


    word[83].vertex_data[0][0] = 0.1;
    word[83].vertex_data[0][1] = 0.8;

    word[83].vertex_data[1][0] = 0.1;
    word[83].vertex_data[1][1] = 0.65;


    word[83].vertex_data[2][0] = 0.175;
    word[83].vertex_data[2][1] = 0.8;

    word[83].vertex_data[3][0] = 0.175;
    word[83].vertex_data[3][1] = 0.65;


    /* $ */
    word[84].pen_num = 3;

    word[84].v_length[0] = 11;
    word[84].v_length[1] = 2;
    word[84].v_length[2] = 2;

    word[84].space = 0.45;


    word[84].vertex_data[0][0] = 0.35;
    word[84].vertex_data[0][1] = 0.55;

    word[84].vertex_data[1][0] = 0.35;
    word[84].vertex_data[1][1] = 0.6;

    word[84].vertex_data[2][0] = 0.30;
    word[84].vertex_data[2][1] = 0.65;

    word[84].vertex_data[3][0] = 0.1;
    word[84].vertex_data[3][1] = 0.65;

    word[84].vertex_data[4][0] = 0.05;
    word[84].vertex_data[4][1] = 0.6;

    word[84].vertex_data[5][0] = 0.05;
    word[84].vertex_data[5][1] = 0.45;


    word[84].vertex_data[6][0] = 0.35;
    word[84].vertex_data[6][1] = 0.4;

    word[84].vertex_data[7][0] = 0.35;
    word[84].vertex_data[7][1] = 0.25;

    word[84].vertex_data[8][0] = 0.3;
    word[84].vertex_data[8][1] = 0.15;

    word[84].vertex_data[9][0] = 0.1;
    word[84].vertex_data[9][1] = 0.15;

    word[84].vertex_data[10][0] = 0.05;
    word[84].vertex_data[10][1] = 0.25;



    word[84].vertex_data[11][0] = 0.15;
    word[84].vertex_data[11][1] = 0.75;

    word[84].vertex_data[12][0] = 0.15;
    word[84].vertex_data[12][1] = 0.05;

    word[84].vertex_data[13][0] = 0.25;
    word[84].vertex_data[13][1] = 0.75;

    word[84].vertex_data[14][0] = 0.25;
    word[84].vertex_data[14][1] = 0.05;


    /* % */
    word[85].pen_num = 3;

    word[85].v_length[0] = 2;
    word[85].v_length[1] = 5;
    word[85].v_length[2] = 5;

    word[85].space = 0.45;

    word[85].vertex_data[0][0] = 0.2;
    word[85].vertex_data[0][1] = 0.625;

    word[85].vertex_data[1][0] = 0.125;
    word[85].vertex_data[1][1] = 0.175;



    word[85].vertex_data[2][0] = 0.1;
    word[85].vertex_data[2][1] = 0.35;

    word[85].vertex_data[3][0] = 0.1;
    word[85].vertex_data[3][1] = 0.45;

    word[85].vertex_data[4][0] = 0.0;
    word[85].vertex_data[4][1] = 0.45;

    word[85].vertex_data[5][0] = 0.0;
    word[85].vertex_data[5][1] = 0.35;

    word[85].vertex_data[6][0] = 0.1;
    word[85].vertex_data[6][1] = 0.35;



    word[85].vertex_data[7][0] = 0.25;
    word[85].vertex_data[7][1] = 0.35;

    word[85].vertex_data[8][0] = 0.25;
    word[85].vertex_data[8][1] = 0.45;

    word[85].vertex_data[9][0] = 0.35;
    word[85].vertex_data[9][1] = 0.45;

    word[85].vertex_data[10][0] = 0.35;
    word[85].vertex_data[10][1] = 0.35;

    word[85].vertex_data[11][0] = 0.25;
    word[85].vertex_data[11][1] = 0.35;


    /* & */
    word[86].pen_num = 1;

    word[86].v_length[0] = 12;

    word[86].space = 0.6;

    word[86].vertex_data[0][0] = 0.4;
    word[86].vertex_data[0][1] = 0.05;

    word[86].vertex_data[1][0] = 0.1;
    word[86].vertex_data[1][1] = 0.5;

    word[86].vertex_data[2][0] = 0.1;
    word[86].vertex_data[2][1] = 0.7;

    word[86].vertex_data[3][0] = 0.15;
    word[86].vertex_data[3][1] = 0.75;

    word[86].vertex_data[4][0] = 0.3;
    word[86].vertex_data[4][1] = 0.75;

    word[86].vertex_data[5][0] = 0.35;
    word[86].vertex_data[5][1] = 0.7;

    word[86].vertex_data[6][0] = 0.35;
    word[86].vertex_data[6][1] = 0.6;

    word[86].vertex_data[7][0] = 0.0;
    word[86].vertex_data[7][1] = 0.3;

    word[86].vertex_data[8][0] = 0.0;
    word[86].vertex_data[8][1] = 0.2;

    word[86].vertex_data[9][0] = 0.05;
    word[86].vertex_data[9][1] = 0.1;

    word[86].vertex_data[10][0] = 0.15;
    word[86].vertex_data[10][1] = 0.1;

    word[86].vertex_data[11][0] = 0.5;
    word[86].vertex_data[11][1] = 0.35;

    /* ~ */
    word[87].pen_num = 1;

    word[87].v_length[0] = 4;

    word[87].space = 0.35;

    word[87].vertex_data[0][0] = 0.0;
    word[87].vertex_data[0][1] = 0.65;

    word[87].vertex_data[1][0] = 0.1;
    word[87].vertex_data[1][1] = 0.8;

    word[87].vertex_data[2][0] = 0.2;
    word[87].vertex_data[2][1] = 0.65;

    word[87].vertex_data[3][0] = 0.3;
    word[87].vertex_data[3][1] = 0.8;

    /* ^ */
    word[88].pen_num = 1;

    word[88].v_length[0] = 3;

    word[88].space = 0.3;

    word[88].vertex_data[0][0] = 0.0;
    word[88].vertex_data[0][1] = 0.65;

    word[88].vertex_data[1][0] = 0.125;
    word[88].vertex_data[1][1] = 0.8;

    word[88].vertex_data[2][0] = 0.25;
    word[88].vertex_data[2][1] = 0.65;


    /* \ */
    word[89].pen_num = 1;

    word[89].v_length[0] = 2;

    word[89].space = 0.5;

    word[89].vertex_data[0][0] = 0.4;
    word[89].vertex_data[0][1] = 0.0;

    word[89].vertex_data[1][0] = 0.0;
    word[89].vertex_data[1][1] = 0.8;

    /* @ */
    word[90].pen_num = 1;

    word[90].v_length[0] = 18;

    word[90].space = 0.65;

    word[90].vertex_data[0][0] = 0.5;
    word[90].vertex_data[0][1] = 0.0;

    word[90].vertex_data[1][0] = 0.2;
    word[90].vertex_data[1][1] = 0.0;

    word[90].vertex_data[2][0] = 0.0;
    word[90].vertex_data[2][1] = 0.1;

    word[90].vertex_data[3][0] = 0.0;
    word[90].vertex_data[3][1] = 0.5;

    word[90].vertex_data[4][0] = 0.2;
    word[90].vertex_data[4][1] = 0.65;

    word[90].vertex_data[5][0] = 0.4;
    word[90].vertex_data[5][1] = 0.65;

    word[90].vertex_data[6][0] = 0.55;
    word[90].vertex_data[6][1] = 0.55;

    word[90].vertex_data[7][0] = 0.55;
    word[90].vertex_data[7][1] = 0.15;

    word[90].vertex_data[8][0] = 0.45;
    word[90].vertex_data[8][1] = 0.15;

    word[90].vertex_data[9][0] = 0.40;
    word[90].vertex_data[9][1] = 0.25;

    word[90].vertex_data[10][0] = 0.40;
    word[90].vertex_data[10][1] = 0.45;

    word[90].vertex_data[11][0] = 0.35;
    word[90].vertex_data[11][1] = 0.55;

    word[90].vertex_data[12][0] = 0.25;
    word[90].vertex_data[12][1] = 0.55;

    word[90].vertex_data[13][0] = 0.15;
    word[90].vertex_data[13][1] = 0.45;

    word[90].vertex_data[14][0] = 0.15;
    word[90].vertex_data[14][1] = 0.25;

    word[90].vertex_data[15][0] = 0.2;
    word[90].vertex_data[15][1] = 0.15;

    word[90].vertex_data[16][0] = 0.3;
    word[90].vertex_data[16][1] = 0.15;

    word[90].vertex_data[17][0] = 0.4;
    word[90].vertex_data[17][1] = 0.3;


    /* { */
    word[91].pen_num = 1;

    word[91].v_length[0] = 7;

    word[91].space = 0.3;

    word[91].vertex_data[0][0] = 0.2;
    word[91].vertex_data[0][1] = 0.8;

    word[91].vertex_data[1][0] = 0.1;
    word[91].vertex_data[1][1] = 0.7;

    word[91].vertex_data[2][0] = 0.1;
    word[91].vertex_data[2][1] = 0.5;

    word[91].vertex_data[3][0] = 0.0;
    word[91].vertex_data[3][1] = 0.4;

    word[91].vertex_data[4][0] = 0.1;
    word[91].vertex_data[4][1] = 0.3;

    word[91].vertex_data[5][0] = 0.1;
    word[91].vertex_data[5][1] = 0.1;

    word[91].vertex_data[6][0] = 0.2;
    word[91].vertex_data[6][1] = 0.0;

    /* } */
    word[92].pen_num = 1;

    word[92].v_length[0] = 7;

    word[92].space = 0.3;

    word[92].vertex_data[0][0] = 0.0;
    word[92].vertex_data[0][1] = 0.8;

    word[92].vertex_data[1][0] = 0.1;
    word[92].vertex_data[1][1] = 0.7;

    word[92].vertex_data[2][0] = 0.1;
    word[92].vertex_data[2][1] = 0.5;

    word[92].vertex_data[3][0] = 0.2;
    word[92].vertex_data[3][1] = 0.4;

    word[92].vertex_data[4][0] = 0.1;
    word[92].vertex_data[4][1] = 0.3;

    word[92].vertex_data[5][0] = 0.1;
    word[92].vertex_data[5][1] = 0.1;

    word[92].vertex_data[6][0] = 0.0;
    word[92].vertex_data[6][1] = 0.0;

    /* ` */
    word[93].pen_num = 1;

    word[93].v_length[0] = 2;

    word[93].space = 0.2;

    word[93].vertex_data[0][0] = 0.05;
    word[93].vertex_data[0][1] = 0.8;

    word[93].vertex_data[1][0] = 0.1;
    word[93].vertex_data[1][1] = 0.65;



    /* space */
    word[94].pen_num = 0;

    word[94].v_length[0] = 0;

    word[94].space = 0.4;

    word[94].vertex_data[0][0] = 0.0;
    word[94].vertex_data[0][1] = 0.0;


    /* \n */
    word[95].pen_num = 0;

    word[95].v_length[0] = 0;

    word[95].space = 1.25;

    word[95].vertex_data[0][0] = 0.0;
    word[95].vertex_data[0][1] = 0.0;


    /*  komoji  */
    int i, j;
    float small_c = 0.70;
    float small_s = 0.8;

    for (i = 0; i < 26; i++) {

	word[26 + i].pen_num = word[i].pen_num;

	for (j = 0; j < 4; j++)
	    word[26 + i].v_length[j] = word[i].v_length[j];

	word[26 + i].space = small_s * word[i].space;

	for (j = 0; j < 20; j++) {
	    word[26 + i].vertex_data[j][0] =
		small_c * word[i].vertex_data[j][0];
	    word[26 + i].vertex_data[j][1] =
		small_c * word[i].vertex_data[j][1];
	}

    }

}
